unit Tower_Hanoi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    RichEdit1: TRichEdit;
    Button2: TButton;
    PrintDialog1: TPrintDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
  procedure move(source,destn,spare,n:integer);
  begin
    if n>1 then move(source,spare,destn,n-1);
    richedit1.lines.add(inttostr(richedit1.lines.count)+'. Moving from '+
                      inttostr(source)+ ' to '+inttostr(destn));
    if n>1 then move(spare,destn,source,n-1);
  end;
begin
  richedit1.clear;
  richedit1.Lines.add(edit1.text+' discs');
  move(1,3,2,strToint(edit1.text));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if printdialog1.execute then richedit1.print('Tower of Hanoi');
end;

end.
